/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CMPRES_H_INCLUDED_
#define _CMPRES_H_INCLUDED_

namespace Sith
{
	namespace Res
	{
		class Colormap : public VFS::Resource
		{
		private:
			struct CMPHEADER
			{
				char Magic[4]; // = "CMP "
				__int32 Version; // = 20
				__int32 Transparency;	// ignore

				__int32 Padding[13];	// what
			};

			// ***** WARNING: LITTLE ENDIAN ONLY *****
            union ColormapElement
			{
                unsigned __int32 RawColor; // 32-bit raw color LOL OMG WTF
				struct
				{
					unsigned char B;
					unsigned char G;
					unsigned char R;
					unsigned char A;
				} Elements;
			};

			ColormapElement Palette[256];
		public:
			Colormap(std::string Name);
			~Colormap();

			SITHERROR LoadFromFile(FILE* FileHandle);

			inline __int32 Get(unsigned int Element)
			{
				return Palette[Element].RawColor;
			};
		};
	};
};

#endif // _CMPRES_H_INCLUDED_