/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "vmtype.h"
#include "opcodes.h"
#include "instruction.h"
#include "vmheap.h"
#include "stackmachine.h"
#include "coglib.h"
#include "console.h"

Sith::System::Console::Console() : Task("CRASH - Complex, Redundant and Absurd Shell")
{
	Sith::System::ConIn::RegisterInput(Stream);

	COG::CogLib::InjectLibraryFunction("Print", 1, &Print);
	COG::CogLib::InjectLibraryFunction("PrintFlex", 1, &PrintFlex);
	COG::CogLib::InjectLibraryFunction("PrintInt", 1, &PrintInt);
	COG::CogLib::InjectLibraryFunction("PrintVector", 1, &PrintVector);

	COG::CogLib::InjectLibraryFunction("Run", 1, &run);

	return;
};

Sith::System::Console::~Console()
{
	return;
};

Sith::SITHERROR Sith::System::Console::Process()
{
	if(Stream.str().length() > 0)
	{
		COG::StackMachine ScriptEngine;

		SITHERROR ErrResult = ScriptEngine.Parse(Stream.str());
		Stream.str("");

		if(Success(ErrResult))
		{
            if(ScriptEngine.Heap.Get(ScriptEngine.Heap.TranslateLocalHeapName("startup"), -1).GetAddr() != -1)
			{
				ScriptEngine.SendMessage("startup", COG::VMType(), -1, COG::VMType());
			}
			else
			{
				ScriptEngine.Execute(0, COG::VMType(), -1, COG::VMType(), COG::VMType(), COG::VMType(), COG::VMType(), COG::VMType());
			};
		};
	};

	return SE_OK;
};