/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CRIBNOTE_H_INCLUDED_
#define _CRIBNOTE_H_INCLUDED_

namespace Sith
{
	namespace Flags
	{
		namespace Actor
		{
			const int HasHeadPitch					= 0x0000001;
			const int CenterView					= 0x0000002;
			const int HasHeadlight					= 0x0000004;
			const int Invulnerable					= 0x0000008;
			const int ViewCentered					= 0x0000010;
			const int ExplodeWhenKilled				= 0x0000020;
			const int WaterBreather					= 0x0000040;
			const int Persuading					= 0x0000080;
			const int CannotBeTargeted				= 0x0000100;
			const int DarkJedi						= 0x0000200;

			const int Blind							= 0x0000800;
			
			const int SaberBlocking					= 0x0002000;

			const int Rooted						= 0x0040000;
			const int CannotAttackWhileUnderwater	= 0x0080000;
			const int CannotBeAutoAimed				= 0x0100000;
			const int Immobilized					= 0x0200000;
			const int Fading						= 0x0400000;
			const int DisableHUD					= 0x0800000;
			const int CriticalHit					= 0x1000000;
		};

		namespace Adjoin
		{
			const int RenderThroughAdjoin			= 0x0000001;
			const int Passable						= 0x0000002;

			const int StopsPlayers					= 0x0000010;
			const int AdjoinDisabled				= 0x0000020;
		};

		namespace AI
		{
			const int MovingToDestination			= 0x0000001;
			const int AttackingTarget				= 0x0000002;
			const int SearchingForTarget			= 0x0000004;
			const int TurningToTarget				= 0x0000008;
			const int DestinationValid				= 0x0000010;
			const int TargetValid					= 0x0000020;

			const int Awake							= 0x0000200;
			const int HasTargetLOS					= 0x0000400;
			const int Fleeing						= 0x0000800;
			const int Peaceful						= 0x0001000;
			const int Disabled						= 0x0002000;
		};

		namespace SurfaceAnimation
		{
			const int Looping						= 0x0000001;
			const int StartOnThirdCelAndSkipFirst	= 0x0000002;
			const int StartOnFourthCelAndSkipFirst2 = 0x0000004;
		};

		namespace SurfaceFlags
		{
			const int Floor							= 0x0000001;
			const int UsedInCOG						= 0x0000002;
			const int Impassable					= 0x0000004;
			const int NotWalkableByAI				= 0x0000008;
			const int DoubleTXScale					= 0x0000010;
			const int HalfTXScale					= 0x0000020;
			const int OneEigthTXScale				= 0x0000040;
			const int NoDamageFromFall				= 0x0000080;
			const int Unknown0						= 0x0000100;
			const int HorizonSky					= 0x0000200;
			const int CeilingSky					= 0x0000400;
			const int Scrolling						= 0x0000800;
			const int Icy							= 0x0001000;
			const int VeryIcy						= 0x0002000;
			const int MagSealed						= 0x0004000;
			const int Unknown1						= 0x0008000;
			const int Metal							= 0x0010000;
			const int DeepWater						= 0x0020000;
			const int ShallowWater					= 0x0040000;
			const int Dirt							= 0x0080000;
			const int VeryDeepWater					= 0x0100000;
			const int FancyWater					= 0x0200000;
			const int BumpyReflective				= 0x0400000;
			const int Unknown2						= 0x0800000;
			const int Unknown3						= 0x1000000;
			const int Unknown4						= 0x2000000;
			const int Unknown5						= 0x4000000;
			const int Unknown6						= 0x8000000;
			const int Unknown7						= 0x10000000;
			const int Unknown8						= 0x20000000;
			const int Unknown9						= 0x40000000;
			const int TexturesMirrored				= 0x80000000;
		};

		namespace Attach
		{
			const int AttachedToSurface				= 0x0000001;
			const int ShareLookVector				= 0x0000002;
			const int AttachedToThing				= 0x0000004;
			const int AttachedToBaseObject			= 0x0000008;
		};

		namespace CameraState
		{
			const int FixedBehindPlayer				= 0x0000001;
		};

		namespace ScriptFlags
		{
			const int Default						= 0x0000000; // ?

			const int Debug							= 0x0000001;
			const int Disabled						= 0x0000002;
			const int Pulsing						= 0x0000004;
			const int Timing						= 0x0000008;
			const int Sleeping						= 0x0000010;
			const int ClassCOG						= 0x0000020;
			const int Local							= 0x0000040;
			const int NotLocal						= 0x0000080;

			const int NoSync						= 0x0000200;
		};

		namespace DamageType
		{
			const int Impact						= 0x0000001;
			const int Energy						= 0x0000002;
			const int Explosion						= 0x0000004;
			const int Force							= 0x0000008;
			const int Saber							= 0x0000010;
			const int Drowning						= 0x0000020;
			const int Collision						= 0x0000040;
		};

		namespace Physics
		{
			const int AffectedByGravity				= 0x0000001;
			const int AcceptsThrust					= 0x0000002;
			const int PlayersActorsGrenades			= 0x0000004;
			const int PlayersActorsSequencers		= 0x0000008;
			const int AlignToFloor					= 0x0000010;
			const int Bouncy						= 0x0000020;
			const int AttachesToFloors				= 0x0000040;
			const int Sticky						= 0x0000080;
			const int AttachedToSurface				= 0x0000100;

			const int IgnoresGravWhileAttached		= 0x0000800;

			const int Flying						= 0x0002000;
			const int MovedByExplosions				= 0x0004000;
			const int AffectedByForce				= 0x0008000;
			const int Crouching						= 0x0010000;

			const int Floating						= 0x0100000;
			const int Falling						= 0x0200000;
			const int IgnoresSectorThrust			= 0x0400000;
		};
	};
};

#endif // _CRIBNOTE_H_INCLUDED_