/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

%option noyywrap
%option prefix="EP"

%{
#include "stdafx.h"

#include "episode.y.hpp"

int EPerror(char *s);
int EPlineno = 1;

YY_BUFFER_STATE EPStringBuffer;

%}

DIGIT	[0-9]
ID		[a-zA-Z_][a-zA-Z0-9_]*

%%

"#"[^\n]*\n /* eat one line comments */ ++EPlineno;
"//"[^\n]*\n	/* eat one line comments */ ++EPlineno;

"TYPE"				return EP_TYPE;
"SEQ"				return EP_SEQ;
"CUT"				return EP_CUT;
"LEVEL"				return EP_LEVEL;
"DECIDE"			return EP_DECIDE;
"end"				return EP_END;

[0-9a-zA-Z_\-]+"."[0-9a-zA-Z_\-]*	{ EPlval.String = strdup(yytext); return EP_FILENAME; }

\"(\\.|[^\\"])*\"	{ EPlval.String = strdup(yytext); return EP_LITERAL_STRING; }

{ID}		{ EPlval.String = strdup(yytext); return EP_IDENTIFIER; }

{DIGIT}+	{ EPlval.Integer = atoi(yytext); return EP_INTEGER; }
"-"{DIGIT}+	{ EPlval.Integer = atoi(yytext); return EP_INTEGER; }

":"				return EP_COLON;

[\n]		++EPlineno;
[ \t\r]+		/* eat whitespace and stupid microsoft stuff */

.	EPerror("Unrecognized character");

%%

bool EPSetInputString(const char* Input)
{
	EPlineno = 1;
	EPStringBuffer = yy_scan_string(Input);
	return true;
};

bool EPCloseInputString()
{
	yy_delete_buffer(EPStringBuffer);
	return true;
};