/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _FFT_H_INCLUDED_
#define _FFT_H_INCLUDED_

namespace Sith
{
	namespace Math
	{
		namespace FFT
		{
			// 2d
			void cdft2d(int, int, int, float **, float *, int *, float *);
			void rdft2d(int, int, int, float **, float *, int *, float *);
			void rdft2dsort(int, int, int, float **);
			void ddct2d(int, int, int, float **, float *, int *, float *);
			void ddst2d(int, int, int, float **, float *, int *, float *);

			// 1d
			void cdft(int, int, float *, int *, float *);
			void rdft(int, int, float *, int *, float *);
			void ddct(int, int, float *, int *, float *);
			void ddst(int, int, float *, int *, float *);
			void dfct(int, float *, float *, int *, float *);
			void dfst(int, float *, float *, int *, float *);



			// helper functions
			void cdft2d_sub(int,int,int,float * *,float *,int *,float *);
			void makewt(int,int *,float *);
			void rdft2d_sub(int,int,int,float * *);
			void makect(int,int *,float *);
			void ddxt2d_sub(int,int,int,int,float * *,float *,int *,float *);
			void cftbsub(int,float *,int *,int,float *);
			void cftfsub(int,float *,int *,int,float *);
			void rftbsub(int,float *,int,float *);
			void rftfsub(int,float *,int,float *);
			void dctsub(int,float *,int,float *);
			void dstsub(int,float *,int,float *);
			void makeipt(int,int *);
			void cftx020(float *);
			void cftf040(float *);
			void bitrv208(float *);
			void cftf081(float *,float *);
			void bitrv216(float *);
			void cftf161(float *,float *);
			void bitrv2(int,int *,float *);
			void cftfx41(int,float *,int,float *);
			void cftleaf(int,int,float *,int,float *);
			void cftrec4(int,float *,int,float *);
			void cftf1st(int,float *,float *);
			void cftb040(float *);
			void bitrv208neg(float *);
			void bitrv216neg(float *);
			void bitrv2conj(int,int *,float *);
			void cftb1st(int,float *,float *);
			int cfttree(int,int,int,float *,int,float *);
			void cftmdl1(int,float *,float *);
			void cftmdl2(int,float *,float *);
			void cftf082(float *,float *);
			void cftf162(float *,float *);
		};
	};
};

#endif // _FFT_H_INCLUDED_