/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _FPSPROC_H_INCLUDED_
#define _FPSPROC_H_INCLUDED_

// Quick and dirty way of showing the immediate framerate
namespace Sith
{
	class FPSProc : public System::Task
	{
	private:
		Sith::Win32::Timer theTimer;
		static double Framerate;

		UI::BaseWidget* Display;

	public:
		FPSProc();

		SITHERROR Startup();
		SITHERROR Process();

		static inline double GetFPS()
		{
			return Framerate;
		};

		// COG binding:
		COGLIBAPI fps()
		{
			std::ostringstream Stream;
			Stream << "Current framerate: " << Framerate << " FPS.\n";
			ConOut(Stream.str(), ConOut::Standard);

			return new COG::VMType(COG::VMTC_VOID);
		};
	};
};

#endif // _FPSPROC_H_INCLUDED_