/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "ogl_render.h"

void Sith::Win32::Renderer::Render3doNode(VFS::WisePointer<Sith::Res::Model> model, int geoset, int node, int sector)
{
	// do siblings
	if (model->Node[node].Sibling != -1)
	{
		Render3doNode(model, geoset, model->Node[node].Sibling, sector);
	}

	Sith::Res::ModelGeoSet *g = &model->GeoSet[geoset];

	if (model->Node[node].Mesh == -1)
		goto nextnode;
	std::vector<Sith::Res::ModelMesh>::iterator m = &g->Mesh[model->Node[node].Mesh];
	if (!m->GeoMode)
		goto nextnode;


//	float intensity;
	/*if (level->SectorList[sector].ExtraLight > 0)
	{
		intensity = .15f + level->SectorList[sector].ExtraLight;
	}
	else
	{
		intensity = 1;
	}*/
//	intensity = 1;
//	glColor4f(intensity, intensity, intensity, 1);


	glPushMatrix();
	glMultMatrixf(model->Node[node].Transform.m);

	/*for (std::vector<Sith::Res::ModelFace>::iterator f = m->Face.begin(); f != m->Face.end(); ++f)
	{
		if (!f->GeoMode)
			continue;
		if (f->Material == -1)
			continue;

		if (f->Type & 0x1)
		{
			glDisable(GL_CULL_FACE);
		}

		if (f->Type & 0x2)
		{
			glAlphaFunc(GL_GREATER, .5f * .352941f);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			//glEnable(GL_ALPHA_TEST);
			glEnable(GL_BLEND);

			glColor4f(intensity, intensity, intensity, .352941f); // 90 / 255
		}

		VFS::WisePointer<Res::Material> mat = model->Material[f->Material];
		glBindTexture(GL_TEXTURE_2D, mat->GetHBM(0).texid[0]);
		glBegin(GL_POLYGON);
		if (m->TexVertex.size())
		{
			for (int v = 0; v < f->VertexList.size(); v++)
			{
				glTexCoord2f(m->TexVertex[f->TexVertexList[v]].u / (mat->GetHBM(0).GetGeometry().xdim * mat->xscale), m->TexVertex[f->TexVertexList[v]].v / (mat->GetHBM(0).GetGeometry().ydim * mat->yscale));
				glVertex3fv(&m->Vertex[f->VertexList[v]].x);
			}
		}
		else
		{
			for (int v = 0; v < f->VertexList.size(); v++)
			{
//				glTexCoord2f(m->TexVertex[f->TexVertexList[v]].u / mat->GetHBM(0).GetGeometry().xdim, m->TexVertex[f->TexVertexList[v]].v / mat->GetHBM(0).GetGeometry().ydim);
				glVertex3fv(&m->Vertex[f->VertexList[v]].x);
			}
		}
		glEnd();

		if (f->Type & 0x1)
		{
			glEnable(GL_CULL_FACE);
		}

		if (f->Type & 0x2)
		{
			glDisable(GL_BLEND);
			glAlphaFunc(GL_GREATER, .5f);
			//glDisable(GL_ALPHA_TEST);
			glColor4f(intensity, intensity, intensity, 1);
		}
	}*/


	glBindBufferARB(GL_ARRAY_BUFFER_ARB, m->drawbuffer);

//	glVertexPointer(3, GL_FLOAT, sizeof(CompiledVertex), m->vertex[0].pos);
//	glNormalPointer(GL_FLOAT, sizeof(CompiledVertex), m->vertex[0].normal);
//	glTexCoordPointer(2, GL_FLOAT, sizeof(CompiledVertex), m->vertex[0].tex);
//	glColorPointer(4, GL_UNSIGNED_BYTE, sizeof(CompiledVertex), m->vertex[0].color);
	glVertexPointer(3, GL_FLOAT, sizeof(CompiledVertex), (void *)offsetof(CompiledVertex, pos));
	glNormalPointer(GL_FLOAT, sizeof(CompiledVertex), (void *)offsetof(CompiledVertex, normal));
	glTexCoordPointer(2, GL_FLOAT, sizeof(CompiledVertex), (void *)offsetof(CompiledVertex, tex));
	glColorPointer(4, GL_UNSIGNED_BYTE, sizeof(CompiledVertex), (void *)offsetof(CompiledVertex, color));
	for (int n = 0; n < m->drawbins; n++)
	{
		if (m->drawsize[n] > 0)
		{
			glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, m->drawindexbuffer[n]);

			VFS::WisePointer<Res::Material> mat = model->Material[n];
			glBindTexture(GL_TEXTURE_2D, mat->GetHBM(0).texid[0]);
			//glDrawElements(GL_TRIANGLES, m->drawsize[n], GL_UNSIGNED_INT, m->drawindex[n]);
			glDrawElements(GL_TRIANGLES, m->drawsize[n], GL_UNSIGNED_INT, (void *)0);
		}
	}

	glPopMatrix();

nextnode:;

	// do children
	if (model->Node[node].NumChildren > 0 && model->Node[node].Child != -1)
	{
		Render3doNode(model, geoset, model->Node[node].Child, sector);
	}
}

void Sith::Win32::Renderer::Render3do(VFS::WisePointer<Sith::Res::Model> model, int sector)
{
	if (sector < 0)
		return;
	if(model.isValid())
	{
//		glEnable(GL_ALPHA_TEST);
 //       glColor4f(1, 1, 1, 1);
		if (model->Node.size())
		{
			Render3doNode(model, 0, 0, sector);
		}
//		glDisable(GL_ALPHA_TEST);
	};

	glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0);
	glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, 0);
}