/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _SERROR_H_INCLUDED_
#define _SERROR_H_INCLUDED_

namespace Sith
{
	typedef enum SITHERROR
	{
		SE_OK,

		SE_GENERAL_WARNING,
		SE_GENERAL_ERROR,
		SE_GENERAL_CRITICAL,

		SE_FILE_WARNING,
		SE_FILE_ERROR,
		SE_FILE_CRITICAL,
		SE_FILE_NOT_FOUND,
		SE_FILE_CORRUPT,
		SE_FILE_INVALID_PATH,

		SE_KERNEL_PANIC,
		SE_KERNEL_QUIT,

		SE_COG_WARNING,
		SE_COG_GENERAL_ERROR,
		SE_COG_PERMISSION_DENIED,
		SE_COG_SYNTAX_ERROR,
		SE_COG_INVALID_TOKEN,
		SE_COG_WARNING_ALREADY_EXISTS,
	};

	inline bool Success(SITHERROR SECode)
	{
		if(SECode == SE_OK)
		{
			return true;
		}
		else
		{
			return false;
		};
	};

	inline bool Failed(SITHERROR SECode)
	{
		if(SECode != SE_OK)
		{
			return true;
		}
		else
		{
			return false;
		};
	};
};

#endif // _SERROR_H_INCLUDED_