/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>

// C RunTime Header Files
#include <math.h>

#include <iostream>
#include <string>
#include <sstream>
#include <list>
#include <vector>
#include <stack>
#include <queue>
#include <map>

#include <algorithm>

#include <io.h>

// GENERAL INCLUDES
#include "serror.h"
#include "cribnote.h"
#include "ksignal.h"
#include "conout.h"
#include "w32_timer.h"
#include "profiler.h"

// USING DIRECTIVES FOR EASINESS:
using Sith::System::ConOut;

// COG VIRTUAL MACHINE INCLUDES
#include "uni.h"
#include "vector.h"
#include "vmtype.h"
#include "vmheap.h"
#include "opcodes.h"
#include "instruction.h"
#include "stackmachine.h"
#include "coglib.h"

// MATH
#include "random.h"
#include "matrix.h"
#include "quaternion.h"

// KERNEL INCLUDES
#include "ktask.h"
#include "kernel.h"

// VIRTUAL FILE SYSTEM INCLUDES
#include "vfile.h"
#include "vdirectory.h"
#include "vfsgob.h"
#include "episode.h"
#include "vfs.h"

// RESOURCE INCLUDES
#include "res.h"
#include "wiseptr.h"
#include "cmpres.h"
#include "ogl_hwbm.h"
#include "matres.h"
#include "cogres.h"
#include "parfile.h"
#include "keyfile.h"
#include "3dofile.h"
#include "invfile.h"
#include "template.h"
#include "thing.h"
#include "jklfile.h"
#include "bmfile.h"
#include "sftfile.h"
#include "resman.h"

// USER INTERFACE INCLUDES
#include "uimain.h"

#include "worldstate.h"

// MORE COG VIRTUAL MACHINE INCLUDES
#include "vmproc.h"
