/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"
#include "resman.h"
#include "uicolors.h"

Sith::Gameplay::Template::Template()
{
	// initialize stuff
	// i suspect once we start implementing physics we'll realize that some of the flags cannot default to 0
	TemplateName = "_ghost";
	ThingFlags = 0;
	TypeFlags = 0;
	Type = TT_FREE;
	Move = MT_NONE;
	Collide = CT_GHOST;
	MoveSize = 0.0f;
	Size = 0.0f;
	AirDrag = 0.0f;
	StaticDrag = 0.0f;
	SurfDrag = 0.0f;
	Buoyancy = 0.0f;
	Mass = 0.0f;
	AngVel = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	MaxRotThrust = 0.0f;
	MaxRotVel = 0.0f;
	MaxThrust = 0.0f;
	Velocity = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	MaxVel = 0.0f;
	Orient = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	PhysFlags = 0.0f;
	PitchRange = 0.0f;
	YawRange = 0.0f;
	COG = VFS::WisePointer<Res::COGScript>(0);
    BlastTime = 0.0f;
	Explode = NULL;
	Debris = NULL;
	FlashRGB = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	FleshHit = NULL;
	Force = 0.0f;
	// Particle = VFS::WisePointer<Res::Particle>(0);
	// Material = VFS::WisePointer<Res::Material>(0);
	// Sprites = VFS::WisePointer<Res::Sprite>(0);
	Model3D = VFS::WisePointer<Res::Model>(0);
	Count = 0;
	ElementSize = 0.0f;
	MinSize = 0.0f;
	Range = 0.0f;
	Rate = 0.0f;
	CreateThing = NULL;
	Damage = 0.0f;
	MinDamage = 0.0f;
	// Aiclass = Sith::VFS::WisePointer<Res::AIClass>(0);
	// Puppet = Sith::VFS::WisePointer<Res::Puppet>(0);
	// Soundclass = Sith::VFS::WisePointer<Res::Soundclass>(0);
	Chance = 0.0f;
	Error = 0.0f;
	EyeOffset = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	FireOffset = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	FOV = 0.0f;
	Health = 0.0f;
	MaxHealth = 0.0f;
	Height = 0.0f;
	JumpSpeed = 0.0f;
	MaxHeadPitch = 0.0f;
	MinHeadPitch = 0.0f;
	Weapon = NULL;
	Weapon2 = NULL;
	Light = 0.0f;
	MaxLight = 0.0f;
	LightIntensity = 0.0f;
	LightOffset = Sith::Math::Vector(0.0f, 0.0f, 0.0f);
	Respawn = 0.0f;
	Timer = 0.0f;
	TrailRandAngle = 0.0f;
	TrailThing = NULL;

	//phew

	return;
};

Sith::Gameplay::Template::Template(std::string Name)
{
	// initialize stuff
	// i suspect once we start implementing physics we'll realize that some of the flags cannot default to 0
	TemplateName = Name;
	ThingFlags = 0;
	TypeFlags = 0;
	Type = TT_FREE;
	Move = MT_NONE;
	MoveSize = 0.0;
	Size = 0.0;
	Collide = CT_GHOST;
	AirDrag = 0.0;
	StaticDrag = 0.0;
	SurfDrag = 0.0;
	Buoyancy = 0.0;
	Mass = 0.0;
	AngVel = Sith::Math::Vector(0.0, 0.0, 0.0);
	MaxRotThrust = 0.0;
	MaxRotVel = 0.0;
	MaxThrust = 0.0f;
	Velocity = Sith::Math::Vector(0.0, 0.0, 0.0);
	MaxVel = 0.0;
	Orient = Sith::Math::Vector(0.0, 0.0, 0.0);
	PhysFlags = 0.0;
	PitchRange = 0.0;
	YawRange = 0.0;
	COG = VFS::WisePointer<Res::COGScript>(0);
    BlastTime = 0.0;
	Explode = NULL;
	Debris = NULL;
	FlashRGB = Sith::Math::Vector(0, 0, 0);
	FleshHit = NULL;
	Force = 0.0f;
	// Particle = VFS::WisePointer<Res::Particle>(0);
	// Material = VFS::WisePointer<Res::Material>(0);
	// Sprites = VFS::WisePointer<Res::Sprite>(0);
	Model3D = VFS::WisePointer<Res::Model>(0);
	Count = 0;
	ElementSize = 0.0;
	MinSize = 0.0;
	Range = 0.0;
	Rate = 0.0;
	CreateThing = NULL;
	Damage = 0.0;
	MinDamage = 0.0;
	// Aiclass = Sith::VFS::WisePointer<Res::AIClass>(0);
	// Puppet = Sith::VFS::WisePointer<Res::Puppet>(0);
	// Soundclass = Sith::VFS::WisePointer<Res::Soundclass>(0);
	Chance = 0.0;
	Error = 0.0;
	EyeOffset = Sith::Math::Vector(0.0, 0.0, 0.0);
	FireOffset = Sith::Math::Vector(0.0, 0.0, 0.0);
	FOV = 0.0;
	Health = 0.0;
	MaxHealth = 0.0;
	Height = 0.0;
	JumpSpeed = 0.0;
	MaxHeadPitch = 0.0;
	MinHeadPitch = 0.0;
	Weapon = NULL;
	Weapon2 = NULL;
	Light = 0.0;
	MaxLight = 0.0;
	LightIntensity = 0.0;
	LightOffset = Sith::Math::Vector(0.0, 0.0, 0.0);
	Respawn = 0.0;
	Timer = 0.0;
	TrailRandAngle = 0.0;
	TrailThing = NULL;

	//phew

	return;
};

void Sith::Gameplay::Template::CopyTemplate (Sith::Gameplay::Template *t)
{
	TemplateName = t->TemplateName;
	ThingFlags = t->ThingFlags;
	TypeFlags = t->TypeFlags;
	Type = t->Type;
	Move = t->Move;
	MoveSize = t->MoveSize;
	Size = t->Size;
	Collide = t->Collide;
	AirDrag = t->AirDrag;
	StaticDrag = t->StaticDrag;
	SurfDrag = t->SurfDrag;
	Buoyancy = t->Buoyancy;
	Mass = t->Mass;
	AngVel = t->AngVel;
	MaxRotThrust = t->MaxRotThrust;
	MaxRotVel = t->MaxRotVel;
	MaxThrust = t->MaxThrust;
	Velocity = t->Velocity;
	MaxVel = t->MaxVel;
	Orient = t->Orient;
	PhysFlags = t->PhysFlags;
	PitchRange = t->PitchRange;
	YawRange = t->YawRange;
	COG = t->COG;
    BlastTime = t->BlastTime;
	Explode = t->Explode;
	Debris = t->Debris;
	FlashRGB = t->FlashRGB;
	FleshHit = t->FleshHit;
	Force = t->Force;
	// Particle = t->Particle;
	// Material = t->Material;
	// Sprites = t->Sprites;
	Model3D = t->Model3D;
	Count = t->Count;
	ElementSize = t->ElementSize;
	MinSize = t->MinSize;
	Range = t->Range;
	Rate = t->Rate;
	CreateThing = t->CreateThing;
	Damage = t->Damage;
	MinDamage = t->MinDamage;
	// Aiclass = t->Aiclass;
	// Puppet = t->Puppet;
	// Soundclass = t->Soundclass;
	Chance = t->Chance;
	Error = t->Error;
	EyeOffset = t->EyeOffset;
	FireOffset = t->FireOffset;
	FOV = t->FOV;
	Health = t->Health;
	MaxHealth = t->MaxHeadPitch;
	Height = t->Height;
	JumpSpeed = t->JumpSpeed;
	MaxHeadPitch = t->MaxHeadPitch;
	MinHeadPitch = t->MinHeadPitch;
	Weapon = t->Weapon;
	Weapon2 = t->Weapon2;
	Light = t->Light;
	MaxLight = t->MaxLight;
	LightIntensity = t->LightIntensity;
	LightOffset = t->LightOffset;
	Respawn = t->Respawn;
	Timer = t->Timer;
	TrailRandAngle = t->TrailRandAngle;
	TrailThing = t->TrailThing;
}

Sith::Gameplay::Template::Template(std::string Name, Sith::Gameplay::Template *Parent)
{
	// Initialize to parent's values
	CopyTemplate (Parent);

	return;
};

Sith::Gameplay::Template::~Template()
{
	Model3D = 0;
	return;
};