/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"
#include "uiwidget.h"

Sith::UI::BaseWidget::BaseWidget()
{
	Geometry = UIRect(0, 0, 0, 0);
	RState = UIRS_NORMAL;

	CSState = UICS_FLAT;
	Color1 = StandardColors::White;
	Color2 = StandardColors::White;

	BSState = UIBS_NONE;
	Image = 0;
	ImageNum = 0;

	WindowText = "";
	Font = 0;
	FontScale = 1.0f;

	Visible = true;

	return;
};

void Sith::UI::BaseWidget::SetColorState(UIColorState _State)
{
	CSState = _State;
	return;
};

void Sith::UI::BaseWidget::Show()
{
	Visible = true;
	return;
};

void Sith::UI::BaseWidget::Hide()
{
	Visible = false;
	return;
};

void Sith::UI::BaseWidget::SetPosition(int x, int y)
{
	Geometry.x = x;
	Geometry.y = y;
	return;
};

void Sith::UI::BaseWidget::SetSize(int width, int height)
{
	Geometry.width = width;
	Geometry.height = height;
	return;
};

void Sith::UI::BaseWidget::SetRect(UIRect Rect)
{
	Geometry = Rect;
	return;
};

void Sith::UI::BaseWidget::SetRectState(UIRectState _State)
{
	RState = _State;
	return;
};

void Sith::UI::BaseWidget::SetColor(UIColor _Color, int ColorNumber)
{
	if(ColorNumber == 2)
	{
		Color2 = _Color;
	}
	else
	{
		Color1 = _Color;
	};

	return;
};

void Sith::UI::BaseWidget::SetBitmapState(UIBitmapState _State)
{
	BSState = _State;
	return;
};

void Sith::UI::BaseWidget::SetBitmapNumber(int BitNum)
{
	ImageNum = BitNum;
	return;
};

void Sith::UI::BaseWidget::SetBitmap(std::string BitmapName)
{
	Image = VFS::ResourceManager::Get().GetBitmap(BitmapName);
	return;
};

void Sith::UI::BaseWidget::SetText(std::string Text)
{
	WindowText = Text;
	return;
};

void Sith::UI::BaseWidget::SetFont(std::string FontName)
{
	Font = VFS::ResourceManager::Get().GetFont(FontName);
	return;
};

void Sith::UI::BaseWidget::SetFontScale(float Scale)
{
	FontScale = Scale;
	return;
};

Sith::UI::UIRect Sith::UI::BaseWidget::GetRect()
{
	return Geometry;
};

Sith::UI::UIRectState Sith::UI::BaseWidget::GetRectState()
{
	return RState;
};

Sith::UI::UIColor Sith::UI::BaseWidget::GetColor(int ColorNumber)
{
	if(ColorNumber == 2)
	{
		return Color2;
	}
	else
	{
		return Color1;
	};
};

Sith::UI::UIColorState Sith::UI::BaseWidget::GetColorState()
{
	return CSState;
};

Sith::UI::UIBitmapState Sith::UI::BaseWidget::GetBitmapState()
{
	return BSState;
};

int Sith::UI::BaseWidget::GetBitmapNumber()
{
	return ImageNum;
};

Sith::VFS::WisePointer<Sith::Res::Bitmap> Sith::UI::BaseWidget::GetBitmap()
{
	return Image;
};

std::string Sith::UI::BaseWidget::GetText()
{
	return WindowText;
};

Sith::VFS::WisePointer<Sith::Res::Font> Sith::UI::BaseWidget::GetFont()
{
	return Font;
};

float Sith::UI::BaseWidget::GetFontScale()
{
	return FontScale;
};

bool Sith::UI::BaseWidget::IsVisible()
{
	return Visible;
};

Sith::UI::BaseWidget& Sith::UI::BaseWidget::CreateChild(BaseWidget Base)
{
	ChildList.push_back(Base);
	return ChildList.back();
};