/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "resman.h"

#include "uni.h"
#include "uni.y.hpp"

Sith::COG::UniTable* GlobalUni;

extern int UNIparse();
extern bool UNISetInputString(const char* Input);
extern bool UNICloseInputString();

Sith::SITHERROR Sith::COG::UniTable::Load(std::string PathName)
{
	GlobalUni = this;

	const char* AsciiResourceBuffer = Sith::VFS::VirtualFileSystem::Get().OpenBuffer(PathName);
	if(!AsciiResourceBuffer)
	{
		ConOut("ERROR: UNI file \'" + PathName + "\' does not exist.\n", ConOut::Error);
		return SE_FILE_NOT_FOUND;
	};

	UNISetInputString(AsciiResourceBuffer);

	if(UNIparse() == 1)
	{
		UNICloseInputString();
		GlobalUni = 0;
		return SE_FILE_CORRUPT;
	}
	else
	{
		UNICloseInputString();
		GlobalUni = 0;
		return SE_OK;
	};

	return SE_OK;
};

