/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

%option noyywrap
%option prefix="UNI"

%{
#include "stdafx.h"

#include "uni.y.hpp"

int UNIerror(char *s);
int UNIlineno = 1;

YY_BUFFER_STATE UNIStringBuffer;
%}

DIGIT	[0-9]

%%

"#"[^\n]*\n		++UNIlineno;
"//"[^\n]*\n	++UNIlineno;

"MSGS"			return UNI_MSGS;
"END"			return UNI_END;

\"([^\"])*\"		{ UNIlval.String = strdup(yytext); return UNI_LITERAL_STRING; }

{DIGIT}+		{ UNIlval.Integer = atoi(yytext); return UNI_INTEGER; }
"-"{DIGIT}+		{ UNIlval.Integer = atoi(yytext); return UNI_INTEGER; }

[\n]			++UNIlineno;
[ \t\r]+

.				// Unrecognized character. Whatever, fucking LEC forgot a 'O' at the bottom of jkstrings so I have to leave this here. Goddamn.

%%

bool UNISetInputString(const char* Input)
{
	UNIlineno = 1;
	UNIStringBuffer = yy_scan_string(Input);
	return true;
};

bool UNICloseInputString()
{
	yy_delete_buffer(UNIStringBuffer);
	return true;
};