/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "vfile.h"
#include "vdirectory.h"
#include "vfsgob.h"

Sith::SITHERROR Sith::VFS::LoadFromGOBFile(VDirectory *TargetDirectory, std::string GOBPath)
{
	FILE* ContainerFile = 0;
	ContainerFile = fopen(GOBPath.c_str(), "rb");
	if(ContainerFile == 0) return SE_FILE_NOT_FOUND;

	GOBFILEHEADER gobheader;
	fread(&gobheader, sizeof(GOBFILEHEADER), 1, ContainerFile);

	if(strncmp(gobheader.Type, "GOB ", sizeof(char) * 4) != 0)
	{
		fclose(ContainerFile);
		return SE_FILE_CORRUPT;
	};

	GOBFILERECORD chunkbuffer;

	std::string pathbuffer;

	VDirectory *CurrentDirectory = 0, *NextDirectory = 0;

	for(unsigned int i = 0; i < gobheader.FileCount; ++i)
	{
		CurrentDirectory = TargetDirectory;

		fread(&chunkbuffer, sizeof(GOBFILERECORD), 1, ContainerFile);

		for(int j = 0; j < 128; ++j)
		{
			if(chunkbuffer.FilePathName[j] == '\\' || chunkbuffer.FilePathName[j] == '/')
			{
				CurrentDirectory = CurrentDirectory->MakeDirectory(pathbuffer);
				pathbuffer.clear();
			}
			else if(chunkbuffer.FilePathName[j] == '\0')
			{
				CurrentDirectory->MakeFile(pathbuffer, GOBPath, chunkbuffer.FileOffset, chunkbuffer.FileLength);
				pathbuffer.clear();
				break;
			}
			else pathbuffer.push_back(chunkbuffer.FilePathName[j]);
		};

		CurrentDirectory = TargetDirectory;
		pathbuffer.clear();
	};

	fclose(ContainerFile);

	return SE_OK;
};