/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// SplitterBar.hpp

// The offset is from bttom or from left in client coords.
// Reposition() returns rect below or to left of bar.


#ifndef _WIN_SplitterBar_HPP_INCLUDED_
#define _WIN_SplitterBar_HPP_INCLUDED_

namespace Sith
{
	namespace Win32
	{
		//TODO: Put all main wdw message constants into a separate header file.
		const UINT  MSG_MOVESPLITTERBAR = WM_USER + 0x4000 + 1;


		//TODO: Get rid of this by making SplitterBar a base class
		//      and deriving a HSplitterBar class and a VSplitterBar class.
		typedef enum
		{
			Horizontal,
			Vertical
		} SplitterBarType;



		class  SplitterBar
		{
		private:
			static const long  Sith::Win32::SplitterBar::SplitterBarThickness;
			static const long  Sith::Win32::SplitterBar::SplitterBarMiddle;

			static LRESULT CALLBACK  ProcessWindow(
				HWND  wdwH, UINT  wdwMsg, WPARAM  wParam, LPARAM  lParam);

			//HINSTANCE  instance;
			static HWND       parentWdwH;

			static SplitterBarType  type;
			std::string           className;
			static HWND             wdwHandle;

			static long  left;
			static long  top;
			static long  width;
			static long  height;
			// For H, offset = distance from client bottom.
			// For V, offset = distance from client left.
			static long  offset;

			static long  dragStart;
			static long  drawOffset;
			static long  drawX;
			static long  drawY;
			static LONG  oldStyle;
			static LONG  style;

			static void  DrawSplitterLine(bool  splitterBarIsDragging = false, 
								SHORT  coord = 0);

		public:
			SplitterBar(HWND  parentWindow, SplitterBarType  type, 
				long  newOffset = -1);
			SplitterBar(const SplitterBar &){};
			~SplitterBar();

			long  GetOffset();
			long  Reposition(RECT &  wdwRect);
			long  ShowWindow(bool  wdwIsVisible);
			HWND  GetWindowHandle();
		};

	};
};

#endif	// _WIN_SplitterBar_HPP_INCLUDED_