/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "wincon.h"

const int Sith::Win32::WinCon::hOutDlgItem = 9001;
const int Sith::Win32::WinCon::hInDlgItem = 9002;
unsigned int Sith::Win32::WinCon::InDlgHeight = 0;
Sith::Win32::SplitterBar *  Sith::Win32::WinCon::horizontalSplitterBarP = NULL;
std::deque<std::string>  Sith::Win32::WinCon::commandBuffer;
long  Sith::Win32::WinCon::commandBufferIndex;

//static WNDPROC  ProcessDefaultInputWdw;
//
//LRESULT CALLBACK  ProcessInputWdw(
//      HWND  hWnd, UINT  uMsg, WPARAM  wParam, LPARAM  lParam)
//{
//      Sith::Win32::WinCon *  winConP;
//      winConP = (Sith::Win32::WinCon *) GetWindowLong(hWnd, GWL_USERDATA);
//
//      if (uMsg == WM_KEYDOWN)
//      {
//              switch(wParam)
//              {
//              case VK_RETURN:
//                      {
//                              int len = GetWindowTextLength(GetDlgItem(hWnd, WinCon::hInDlgItem));
//                              if(len > 0)
//                              {
//                                      char* buffer;
//
//                                      buffer = (char*)GlobalAlloc(GPTR, len + 1);
//
//                                      GetDlgItemText(hWnd, WinCon::hInDlgItem, buffer, len + 1);
//
//                                      Sith::ConIn(std::string(buffer));
//                                      ConOut(std::string(buffer) + std::string("\n"), ConOut::Echo);
//
//                                      if (commandBuffer.size() == 50)
//                                      {
//                                              commandBuffer.pop_front();
//                                      }
//                                      commandBuffer.push_back(std::string(buffer));
//                                      commandBufferIndex = commandBuffer.size() - 1;
//
//                                      GlobalFree(buffer);
//
//                                      SetDlgItemText(hWnd, WinCon::hInDlgItem, "");
//                              };
//                      }
//                      break;
//              case VK_UP:
//                      {
//                              ++commandBufferIndex;
//                              if (commandBufferIndex >= commandBuffer.size())
//                              {
//                                      commandBufferIndex = commandBuffer.size() - 1;
//                              }
//                              SetDlgItemText(hWnd, WinCon::hInDlgItem, commandBuffer[commandBufferIndex].c_str());
//                      }
//                      break;
//              case VK_DOWN:
//                      {
//                              --commandBufferIndex;
//                              if (commandBufferIndex < 0)
//                              {
//                                      commandBufferIndex = 0;
//                              }
//                              SetDlgItemText(hWnd, WinCon::hInDlgItem, commandBuffer[commandBufferIndex].c_str());
//                      }
//                      break;
//              }
//      }
//
//      return CallWindowProc(ProcessDefaultInputWdw,
//              hWnd, uMsg, wParam, lParam);
//}

LRESULT CALLBACK Sith::Win32::WinCon::ConWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
       switch(uMsg)
       {
       case WM_CREATE:
               {
                       HFONT hfDefault;
                       HWND hOutWnd = NULL;
                       HWND hInWnd = NULL;

                       hOutWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_MULTILINE | ES_AUTOVSCROLL | ES_READONLY,
                               0, 0, 0, 0, hWnd, (HMENU)hOutDlgItem, GetModuleHandle(NULL), NULL);

                       if(hOutWnd == NULL)
                       {
                               MessageBox(GetDesktopWindow(), "Failed to create console output window", "Error", MB_OK | MB_ICONERROR);
                               ConOut("Critical error: Failed to create console output window\n", ConOut::Critical);
							   Sith::System::Kernel::Get().SendSignal(Sith::KS_QUIT);

                               return 0;
                       }

                       hInWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_WANTRETURN, 0, 0, 0, 0, hWnd, (HMENU)hInDlgItem, GetModuleHandle(NULL), NULL);

                       if(hInWnd == NULL)
                       {
                               MessageBox(GetDesktopWindow(), "Failed to create console input window", "Error", MB_OK | MB_ICONERROR);
                               ConOut("Critical error: Failed to create console output window\n", ConOut::Critical);
							   Sith::System::Kernel::Get().SendSignal(Sith::KS_QUIT);

                               return 0;
                       }

                       //ProcessDefaultInputWdw
                       //      = (WNDPROC)SetWindowLong(hInWnd, GWL_WNDPROC,
                       //              (long)ProcessInputWdw);
                       //SetWindowLong(hInWnd, GWL_USERDATA, (long) this);

                       SIZE InRgn;
                       GetTextExtentPoint32(GetDC(hInWnd), "Aa|", 3, &InRgn);

                       RECT InRect;
                       InRect.left = 0;
                       InRect.top = 0;
                       InRect.right = InRgn.cx;
                       InRect.bottom = InRgn.cy;

                       AdjustWindowRectEx(&InRect, WS_CHILD | WS_VISIBLE, FALSE, WS_EX_CLIENTEDGE);

                       InDlgHeight = InRect.bottom - InRect.top + 3;

                       RECT rcClient;
                       GetClientRect(hWnd, &rcClient);
                       horizontalSplitterBarP = new Sith::Win32::SplitterBar(hWnd, Horizontal,
                               (long) InDlgHeight);
                       horizontalSplitterBarP->ShowWindow(true);

                       hfDefault = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
                       SendMessage(hOutWnd, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));

                       Redraw(hWnd, uMsg, wParam, lParam);
               }
               break;

       //case WM_SIZE:
       case WM_WINDOWPOSCHANGED:
               {
                       LPWINDOWPOS wp = (LPWINDOWPOS)lParam;
                       if (wp->flags & SWP_NOSIZE)  // if set
                       {
                               break;
                       }
               }
       case MSG_MOVESPLITTERBAR:
               Redraw(hWnd, uMsg, wParam, lParam);
               break;

       case WM_ACTIVATE:
               SetFocus(GetDlgItem(hWnd, WinCon::hInDlgItem));
               break;

       case WM_CLOSE:
               DestroyWindow(hWnd);
               break;

       case WM_DESTROY:
			   Sith::System::Kernel::Get().SendSignal(Sith::KS_QUIT);
               break;

       case WM_KEYDOWN:
               {
                       switch(wParam)
                       {
                       case VK_RETURN:
                               {
                                       if (GetKeyState(VK_CONTROL) & 0x8000)
                                       {
                                               SendMessage(GetDlgItem(hWnd, WinCon::hInDlgItem), EM_REPLACESEL, (WPARAM) TRUE, (LPARAM) "\r\n");
                                               break;
                                       }

                                       int len = GetWindowTextLength(GetDlgItem(hWnd, WinCon::hInDlgItem));
                                       if(len > 0)
                                       {
                                               char* buffer;

                                               buffer = (char*)GlobalAlloc(GPTR, len + 1);

                                               GetDlgItemText(hWnd, WinCon::hInDlgItem, buffer, len + 1);

											   Sith::System::ConIn(std::string(buffer));
                                               ConOut(std::string(buffer) + std::string("\n"), ConOut::Echo);

                                               if (commandBuffer.size() == 50)
                                               {
                                                       commandBuffer.pop_front();
                                               }
                                               commandBuffer.push_back(std::string(buffer));
                                               commandBufferIndex = commandBuffer.size();

                                               GlobalFree(buffer);

                                               SetDlgItemText(hWnd, WinCon::hInDlgItem, "");
                                       }
                               }
                               break;
                       case VK_UP:
                               {
                                       if (!commandBuffer.empty())
                                       {
                                               --commandBufferIndex;
                                               if (commandBufferIndex < 0)
                                               {
                                                       commandBufferIndex = 0;
                                               }
                                               SetDlgItemText(hWnd, WinCon::hInDlgItem, "");
                                               SendMessage(GetDlgItem(hWnd, WinCon::hInDlgItem), EM_REPLACESEL, (WPARAM) FALSE, (LPARAM) commandBuffer[commandBufferIndex].c_str());
                                       }
                               }
                               break;
                       case VK_DOWN:
                               {
                                       if (!commandBuffer.empty())
                                       {
                                               ++commandBufferIndex;
                                               if (commandBufferIndex >= commandBuffer.size())
                                               {
                                                       commandBufferIndex = commandBuffer.size();
                                                       SetDlgItemText(hWnd, WinCon::hInDlgItem, "");
                                               }
                                               else
                                               {
                                                       SetDlgItemText(hWnd, WinCon::hInDlgItem, "");
                                                       SendMessage(GetDlgItem(hWnd, WinCon::hInDlgItem), EM_REPLACESEL, (WPARAM) FALSE, (LPARAM) commandBuffer[commandBufferIndex].c_str());
                                               }
                                       }
                               }
                               break;
                       }
               }
               break;

       default:
               return DefWindowProc(hWnd, uMsg, wParam, lParam);
       }

       return 0;
}

Sith::Win32::WinCon::Redraw(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
       HWND hOutWnd;
       HWND hInWnd;
       RECT rcClient;

       GetClientRect(hWnd, &rcClient);

       hOutWnd = GetDlgItem(hWnd, WinCon::hOutDlgItem);
       hInWnd = GetDlgItem(hWnd, WinCon::hInDlgItem);

       RECT hSplitterBarRect;
       hSplitterBarRect = rcClient;
       horizontalSplitterBarP->Reposition(hSplitterBarRect);
       InDlgHeight = rcClient.bottom - (hSplitterBarRect.top + hSplitterBarRect.bottom);

       SetWindowPos(hOutWnd, NULL, 0, 0, rcClient.right, rcClient.bottom - hSplitterBarRect.bottom - InDlgHeight, SWP_NOZORDER);
       SetWindowPos(hInWnd, NULL, 0, hSplitterBarRect.top + hSplitterBarRect.bottom, rcClient.right, InDlgHeight, SWP_NOZORDER);

       RedrawWindow(hWnd, NULL, NULL,
               RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);
}

Sith::Win32::WinCon::WinCon() : Task("Win32 UI Console")
{
       ConOut::RegisterOutput(Stream, ConOut::Standard | ConOut::Network | ConOut::Echo | ConOut::Warning |
                                                                                       ConOut::Error | ConOut::Critical | ConOut::Pedantic);

       wc.cbSize = sizeof(WNDCLASSEX);
       wc.style = 0;
       wc.lpfnWndProc = ConWndProc;
       wc.cbClsExtra = 0;
       wc.cbWndExtra = 0;
       wc.hInstance = GetModuleHandle(NULL);
       wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
       wc.hCursor = LoadCursor(NULL, IDC_ARROW);
       wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
       wc.lpszMenuName = NULL;
       wc.lpszClassName = "Sith2 Console";
       wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

       if(!RegisterClassEx(&wc))
       {
               MessageBox(GetDesktopWindow(), "Failed to register console window class", "Error", MB_OK | MB_ICONERROR);
               ConOut("Critical error: Failed to register console window class\n", ConOut::Critical);
			   Sith::System::Kernel::Get().SendSignal(Sith::KS_QUIT);

               return;
       };

       hMainWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "Sith2 Console", "Cogsole", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
               800, 600, NULL, NULL, GetModuleHandle(NULL), NULL);

       if(hMainWnd == NULL)
       {
               MessageBox(GetDesktopWindow(), "Failed to create console window", "Error", MB_OK | MB_ICONERROR);
               ConOut("Critical error: Failed to create console window\n", ConOut::Critical);
			   Sith::System::Kernel::Get().SendSignal(Sith::KS_QUIT);

               return;
       };

       ShowWindow(hMainWnd, SW_SHOWDEFAULT);
       UpdateWindow(hMainWnd);

       return;
};

Sith::Win32::WinCon::~WinCon()
{
       delete horizontalSplitterBarP;
       horizontalSplitterBarP = NULL;
       return;
};

Sith::SITHERROR Sith::Win32::WinCon::Process()
{
       if(Stream.str().length() > 0)
       {
               for(unsigned int i = 0; i < Stream.str().length(); ++i)
               {
                       if(Stream.str()[i] == '\n')
                       {
                               TextBuffer.push_back('\r');
                               TextBuffer.push_back('\n');
                       }
                       else TextBuffer.push_back(Stream.str()[i]);
               };

               Stream.str("");

               HWND hEdit = GetDlgItem(hMainWnd, hOutDlgItem);

               SetDlgItemText(hMainWnd, hOutDlgItem, TextBuffer.c_str());
               SendMessage(hEdit, WM_VSCROLL, SB_BOTTOM, NULL);
       };

       if(TextBuffer.length() > 16384) // if the buffer's length is greater than 16384 bytes, truncate
       {
               TextBuffer.erase(0, 2048);
               TextBuffer = std::string(TextBuffer); // reset allocators
       };

       // Win32 Message Pump:
       while(PeekMessage(&Msg, hMainWnd, 0U, 0U, PM_REMOVE) > 0)
       {
               if((Msg.message == WM_KEYDOWN)
                       && (
                       (Msg.wParam == VK_RETURN)
                       || (Msg.wParam == VK_UP)
                       || (Msg.wParam == VK_DOWN) ) )
               {
                       Msg.hwnd = hMainWnd;
               };

               TranslateMessage(&Msg);
               DispatchMessage(&Msg);
       };

       return Sith::SE_OK;
};